routes/web.php
<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\UserController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\AnnounceController;
use App\Http\Controllers\CompanyController;



/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/




Auth::routes();
Route::get('/', [HomeController::class, 'front'])->name('front');
Route::get('/dashboard', [HomeController::class, 'index'])->name('dashboard');
//Route::get('announce_add/save', [AnnounceController::class, 'saveRecord'])->name('announce_add/save');

Route::resource('role', RoleController::class);
Route::resource('user', UserController::class);
Route::resource('announce', AnnounceController::class);
// Route::resource('announce_list', AnnounceController::class);
//Route::resource('announce_add', AnnounceController::class);

Route::resource('company', CompanyController::class);
Route::get('reports',[HomeController::class, 'reportForm'])->name('report.form');
Route::get('rfq/report',[HomeController::class, 'rfqReport'])->name('rfq.report');
Route::get('company/list/{id}',[HomeController::class, 'companyList'])->name('company.list');

Route::view('/test', 'layouts.main');

app/Http/Controllers/RoleController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;
use Auth;

class RoleController extends Controller
{
      /**
       * Create a new controller instance.
       *
       * @return void
       */
      public function __construct()
      {
          // $this->middleware('guest');
          $this->middleware('auth');
      }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        if(!Auth::user()->can('role_show'))
          return view('user.access');

        $roles = Role::all();
        return view('role.create', compact('roles'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        if(!Auth::user()->can('role_add'))
          return view('user.access');

        $roles = Role::all();
        return view('role.create', compact('roles'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        if(!Auth::user()->can('role_add'))
          return view('user.access');

        $request->validate([
            "role_name" => "required",
        ]);
        $role = Role::create(['name' => $request->role_name]);
        return redirect()->route('role.index')->with('message', __('general.'));
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        if(!Auth::user()->can('role_show'))
          return view('user.access');

        $permissions = Permission::all();
        $data = [];

        foreach ($permissions as $key => $permission) {
          if (strpos($permission->name, 'apartment') !== FALSE) { // Yoshi version
              $data['apartment'][] = $permission;
          }
          if (strpos($permission->name, 'shahrak') !== FALSE) { // Yoshi version
              $data['shahrak'][] = $permission;
          }
          if (strpos($permission->name, 'land') !== FALSE) { // Yoshi version
              $data['land'][] = $permission;
          }
          if (strpos($permission->name, 'payment') !== FALSE) { // Yoshi version
              $data['payment'][] = $permission;
          }
          if (strpos($permission->name, 'resident') !== FALSE) { // Yoshi version
              $data['resident'][] = $permission;
          }
          if (strpos($permission->name, 'document') !== FALSE) { // Yoshi version
              $data['document'][] = $permission;
          }
          if (strpos($permission->name, 'user') !== FALSE) { // Yoshi version
              $data['user'][] = $permission;
          }
          if (strpos($permission->name, 'role') !== FALSE) { // Yoshi version
              $data['role'][] = $permission;
          }
        }

        $role = Role::find($id);
        $rolePermissions = $role->getPermissionNames()->toArray();

        return view('role.permissions', compact('data', 'id', 'rolePermissions'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        if(!Auth::user()->can('role_edit'))
          return view('user.access');

        $permissions = $request->permission_id;

        $role = Role::find($id);
        $role->syncPermissions($permissions);
        return redirect()->route('role.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/role/create.blade.php
@extends('app')

@section('page_title',__('general.add_role'))

@section('body')
       <div class="card card-secondary">
            <div class="card-header">
              <h3 class="card-title rtl">{{__('general.add_role')}}</h3>
            </div>

            <div class="card-body">
              <form action="{{ route('role.store') }}" method="POST">
                @csrf
                <div class="row">

                    <div class="form-group col-sm-4">
                      <label for="role_name">{{__('general.role_name')}}</label>
                      <input value="{{ old('role_name') }}" type="text" class="form-control" id="role_name" name="role_name">
                     @error('page')
                      <span style="color: red;">*  {{ $message }} </span>
                      @enderror
                    </div>

                  </div>
                  <button type="submit" class="btn btn-info btn-flat">{{__('general.add_role')}}</button>
              </form>
              <hr/>
              <div class="row">
                <div class="col-md-12">
                  <table class="table table-bordered">
                  <thead>
                    <tr>
                      <th style="width: 10px">#</th>
                      <th>{{__('general.role_name')}}</th>
                      <th>{{__('general.options')}}</th>

                    </tr>
                  </thead>
                  <tbody>
                    @foreach($roles as $role)
                      <tr>
                        <td>{{ $role->id }}</td>
                        <td>{{ $role->name }}</td>
                        <td>
                          <a class="btn btn-info btn-xs" href="{{ route('role.show', $role->id) }}">{{__('general.permissions')}} </a>

                            <a class="btn btn-danger btn-xs" href="#">{{__('general.delete')}}</a>
                        </td>

                      </tr>
                      @endforeach
                  </tbody>
                  </table>
                </div>
              </div>
            </div>

            <!-- /.card-body -->
          </div>
        </div>
@endsection

resources/views/role/permissions.blade.php
@extends('app')

@section('page_title',__('general.permissions'))

@section('body')
       <div class="card card-secondary">
            <div class="card-header">
              <h3 class="card-title rtl">{{__('general.permissions')}}</h3>
            </div>

            <div class="card-body">
              <div class="row">
                <div class="col-md-12">
                  <form action="{{ route('role.update', $id) }}" method="POST">
                    @csrf
                    @method('PUT')
                  <table class="table table-bordered">
                  <thead>
                    <tr>
                      <th>
                        {{__('general.title')}}
                      </th>
                      <th>
                        {{__('general.permissions')}}
                      </th>
                    </tr>
                  </thead>
                  <tbody>
                    @foreach($data as $key => $permissions)
                      <tr>
                        <td>{{__('general.'.$key.'s')}}</td>
                        @foreach($permissions as $permission)
                          <td>
                            <input name="permission_id[]"type="checkbox" class="role-check" value="{{ $permission->id }}" @if(in_array($permission->name, $rolePermissions)) checked @endif>
                              {{ __('role.'.$permission->name) }}
                            </td>
                        @endforeach
                      </tr>
                    @endforeach
                  </tbody>
                  </table>
                  <button type="submit" class="btn btn-info btn-flat">{{__('general.update_role')}}</button>
                </form>
                </div>
              </div>
            </div>
        </div>
@endsection